<?php
// $Id$

/*
 * Generate list of all users in domain
 */
function domain_admin_user_list($domain) {
  
  drupal_set_message($domain['domain_id']);

  $form['adduser'] = array(
    '#type' => 'fieldset',
    '#title' => t('Add user to domain'),
    '#prefix' => '<div class="container-inline">',
    '#suffix' => '</div>',
  );
  
  $form['adduser']['user'] = array(
    '#type' => 'textfield',
    '#title' => t('User name'),
    '#maxlength' => 60,
    '#autocomplete_path' => 'user/autocomplete',
    '#weight' => -1,
    '#required' => TRUE,
  ); 
  
  $form['adduser']['domain_id'] = array(
    '#type' => 'value',
    '#value' => $domain['domain_id'],
  );  

  $form['adduser']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Add user'),
  );
  
    $header = array(
    array(),
    array('data' => t('Username'), 'field' => 'u.name'),
    array('data' => t('Status'), 'field' => 'u.status'),
    t('Roles'),
    array('data' => t('Member for'), 'field' => 'u.created', 'sort' => 'desc'),
    array('data' => t('Last access'), 'field' => 'u.access'),
    t('Operations')
  );
  
  $query = db_query('SELECT DISTINCT u.uid, u.name, u.status, u.created, u.access FROM {users} u JOIN {domain_editors} d ON u.uid = d.uid WHERE u.uid != 0 AND d.domain_id = %d', $domain['domain_id']);

  $destination = drupal_get_destination();

  $status = array(t('blocked'), t('active'));
  $roles = user_roles(TRUE);
  $accounts = array();
  while ($account = db_fetch_object($query)) {
    $accounts[$account->uid] = '';
    $form['name'][$account->uid] = array('#value' => theme('username', $account));
    $form['status'][$account->uid] =  array('#value' => $status[$account->status]);
    $users_roles = array();
    $roles_result = db_query('SELECT rid FROM {users_roles} WHERE uid = %d', $account->uid);
    while ($user_role = db_fetch_object($roles_result)) {
      $users_roles[] = $roles[$user_role->rid];
    }
    asort($users_roles);
    $form['roles'][$account->uid][0] = array('#value' => theme('item_list', $users_roles));
    $form['member_for'][$account->uid] = array('#value' => format_interval(time() - $account->created));
    $form['last_access'][$account->uid] =  array('#value' => $account->access ? t('@time ago', array('@time' => format_interval(time() - $account->access))) : t('never'));
    $form['operations'][$account->uid] = array('#value' => l(t('edit'), "user/$account->uid/edit", array('query' => $destination)));
  }
  $form['accounts'] = array(
    '#type' => 'checkboxes',
    '#options' => $accounts
  );
  $form['pager'] = array('#value' => theme('pager', NULL, 50, 0));
  
  $form['#theme'] = 'user_admin_account';

  return $form;
}

/**
 * Submit the user update form.
 */
function domain_admin_user_list_submit($form, &$form_state) {
  
  if (!empty($form_state['values']['user'])) {
    $uid = db_result(db_query("SELECT uid FROM {users} WHERE name = '%s'", $form_state['values']['user']));
  
    $editor = db_result(db_query('SELECT uid FROM {domain_editor} WHERE uid = %d AND domain_id = %d', $uid, $form_state['values']['domain_id']));
    
    if (!empty($editor)) {
      drupal_set_message(t('User is already in domain.')); 
    }
    else { 
      $domain_editor = new stdClass;
      $domain_editor->uid = $uid;
      $domain_editor->uid = $form_state['values']['domain_id'];      
      drupal_write_record('domain_editor', $domain_editor);
      drupal_set_message(t('The update has been performed.'));
    }  
  }  
}


